/* Sistemas Integrados TEKNISA
Nome: 0103_SDXTRGO_SDX_CANCELA_IMPORTACAO.sql

C:\Web_509\Sql\End_Conv\Oracle\Clientes\Sdx\0103_SDXTRGO_SDX_CANCELA_IMPORTACAO.sql

Descrio:
Rotina para permitir que as notas fiscais importadas
fiquem disponiveis para uma nova importao.

Criao:
17/08/2010 - Cleison Rafael da Silva Ferreira
*/

CREATE OR REPLACE TRIGGER SDX_CANCELA_IMPORTACAO
AFTER DELETE ON NOTAFISCAL FOR EACH ROW
DECLARE
  V_CDNOTAFISCORIG  VARCHAR2(20);
BEGIN
   IF (:OLD.SDX_CDNOTAFISCORIG IS NOT NULL) THEN
      BEGIN
         SELECT CDNOTAFISCORIG
           INTO V_CDNOTAFISCORIG
           FROM SDX_CONTROLEINT
          WHERE CDNOTAFISCORIG = :OLD.SDX_CDNOTAFISCORIG
            AND IDINSCANCNF = '2';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDNOTAFISCORIG := NULL;
      END;

      IF (V_CDNOTAFISCORIG IS NULL) THEN
         UPDATE SDX_CONTROLEINT
            SET DTIMPORTACAO = NULL
          WHERE CDNOTAFISCORIG = :OLD.SDX_CDNOTAFISCORIG
            AND IDINSCANCNF = '1';

         UPDATE SDX_NOTAFISCAL
            SET IDMARCIMPORTA = 'N'
          WHERE CDNOTAFISCORIG = :OLD.SDX_CDNOTAFISCORIG;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('SDX_EXCLUI_NF_DEVOLUCAO','5.11.000'); END;
/