CREATE TABLE OM_CONFIG_COLETA(
  ID                  	NUMBER 		NOT NULL,
  QTD_DIAS_REAPLICAR 	NUMBER 		NOT NULL,
  DT_LIMITE          	DATE 		NOT NULL,
  PHP_SCRIPT_LOG     	CLOB 		NOT NULL,
  NRPRODUTO_ID          NUMBER      NOT NULL,
  NRORG          		NUMBER 		DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
  NRORGINCLUSAO  		NUMBER 		DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
  NRORGULTATU    		NUMBER 		DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
  DTINCLUSAO     		DATE,
  DTULTATU       		DATE,
  CDOPERINCLUSAO 		VARCHAR2(12),
  CDOPERULTATU   		VARCHAR2(12),
  IDATIVO        		VARCHAR2(1) DEFAULT 'S' NOT NULL,
	CONSTRAINT PK_OM_CONFIG_COLETA          PRIMARY KEY(ID),
	CONSTRAINT CKC_IDATIVO_OM_CONFIG_COLETA CHECK (IDATIVO IN ('S', 'N')),
    CONSTRAINT FK_OM_PROD_OM_CONFIG_COLETA  FOREIGN KEY (NRPRODUTO_ID) REFERENCES OM_PRODUTO (ID)
)
/
CREATE TABLE OM_CONFIG_COLETA_ORG (
  ID             NUMBER NOT NULL,
  NRCONFCOL_ID   NUMBER NOT NULL,
  NRORG_ID       NUMBER NOT NULL,
  
  NRORG          NUMBER NOT NULL, 
  IDATIVO        VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  DTINCLUSAO     DATE, 
  DTULTATU       DATE, 
  NRORGINCLUSAO  NUMBER, 
  CDOPERINCLUSAO VARCHAR2(12), 
  NRORGULTATU    NUMBER, 
  CDOPERULTATU   VARCHAR2(12),
  
  CONSTRAINT PK_OM_CONFIG_COLETA_ORG     PRIMARY KEY(ID),
  CONSTRAINT CKC_IDATIVO_OM_CONF_COL_ORG CHECK (IDATIVO IN ('S','N'))
)

/
ALTER TABLE OM_PRODUTO ADD IDPERDEPLOY VARCHAR2(1) DEFAULT 'S' NOT NULL
/
ALTER TABLE OM_PRODUTO ADD CONSTRAINT CKC_IDPERDEPLOY_OM_PRODUTO CHECK (IDPERDEPLOY IN ('S','N'))
/